%define name smeserver-kplaylist
%define version 1.7.426
%define release 1
%define rpmver  4.0.4


Summary:            kPlaylist is a free PHP system that makes your music collection available via the Internet.
Name:               %{name}
Version:            %{version}
Release:            %{release}%{?dist}
License:          GPL
Group:              SME/Addon
Source:             %{name}-%{version}.tar.gz
URL:                http://www.kplaylist.net/
BuildRoot:          /var/tmp/%{name}-%{version}-%{release}-buildroot
BuildArchitectures: noarch
Requires:           e-smith-base
Requires:           e-smith-release >= 7
BuildRequires:      e-smith-devtools


%description
This RPM is an unofficial addon for the SME Server 7.x.
kPlaylist is a free PHP system that makes your music collection available via the Internet.
http://yourdomain.com/kplaylist


%changelog
* Sat Nov 24 2007 Sylvain Gomez <sylvaingomez@free.fr>
[1.7.426-1] Original version


%prep


%setup


%build
# Default DB parameters
DEFAULTS1=root/etc/e-smith/db/configuration/defaults/kplaylist
DEFAULTS2=root/etc/e-smith/db/accounts/defaults/kplaylist
mkdir -p $DEFAULTS1
mkdir -p $DEFAULTS2
echo "kplaylist" > $DEFAULTS1/DbName
echo "kplaylist" > $DEFAULTS1/DbUser
echo "off"       > $DEFAULTS1/HTTPS
echo "16M"       > $DEFAULTS1/MaxUpload
echo "KPlaylist" > $DEFAULTS1/Name
echo "local"     > $DEFAULTS1/PublicAccess
echo "service"   > $DEFAULTS1/type
echo "url"       > $DEFAULTS2/type

# Creating templates.metadata
TEMPLATE1=root/etc/e-smith/templates.metadata/etc/e-smith/sql/init
mkdir -p $TEMPLATE1
echo 'PERMS=0540' >  $TEMPLATE1/80kplaylist_mysql.sql


%install
rm -rf $RPM_BUILD_ROOT
(cd root ; find . -depth -print | cpio -dump $RPM_BUILD_ROOT)
rm -f %{name}-%{version}-filelist
/sbin/e-smith/genfilelist $RPM_BUILD_ROOT > %{name}-%{version}-filelist


%clean 
rm -rf $RPM_BUILD_ROOT


%pre
# Checking if KPlaylist files are present before updating
# If present, installation files + MySQL DB + DB values are saved
if [ -d /opt/kplaylist ]; then
  case $LANG in
    fr_FR) echo "Sauvegarde de l'ancienne install dans /opt/RPM_BACKUP" ;;
        *) echo "Backing up old install in /opt/RPM_BACKUP" ;;
  esac
  mkdir -p /opt/RPM_BACKUP
  cd /opt/kplaylist
  tar -czf /opt/RPM_BACKUP/html.tar.gz html
  mysqldump kplaylist > /opt/RPM_BACKUP/kplaylist.sql
  /sbin/e-smith/db configuration show kplaylist > /opt/RPM_BACKUP/kplaylist-config.txt
fi


%post
# Initializing SME DB
/etc/e-smith/events/actions/initialize-default-databases

# Variables
SRVNAME=$(/sbin/e-smith/db configuration get SystemName)
KPLPASS=$(/sbin/e-smith/db configuration getprop kplaylist DbPassword)
if [ -d /opt/kplaylist ]  ; then UPDATE=1  ; else UPDATE=0  ; fi

# Basic structure
mkdir -p /opt/kplaylist/{files,html}
chown www:www  /opt/kplaylist/files
chmod 3770     /opt/kplaylist/files
chown root:www /opt/kplaylist/html
chmod 770      /opt/kplaylist/html

# Creating index.php
sed 's.yourpassword.'$KPLPASS'.g' /usr/share/doc/kplaylist-1.7.426/Sources/kplaylist.1.7.426.php > /opt/kplaylist/html/index.php
chown root:www /opt/kplaylist/html/index.php
chmod 660      /opt/kplaylist/html/index.php

# MySQL installation
/sbin/e-smith/expand-template /etc/e-smith/sql/init/80kplaylist_mysql.sql
if [ "$UPDATE" = "0" ] ; then
  if [ -f /usr/share/doc/kplaylist-1.7.426/Sources/$LANG.sql ] ;then
    cp /usr/share/doc/kplaylist-1.7.426/Sources/$LANG.sql /etc/e-smith/sql/init/81kplaylist_db.sql
  else
    cp /usr/share/doc/kplaylist-1.7.426/Sources/en_US.sql /etc/e-smith/sql/init/81kplaylist_db.sql
  fi
fi
/etc/rc.d/init.d/mysql.init start 2>/dev/null >/dev/null

# Applying modifications
/sbin/e-smith/expand-template /etc/samba/smb.conf
/sbin/e-smith/expand-template /etc/httpd/conf/httpd.conf
/etc/init.d/smbd restart 2>/dev/null >/dev/null
service smb restart 2>/dev/null >/dev/null
/etc/rc7.d/S86httpd-e-smith sigusr1 2>/dev/null >/dev/null

echo "-------------------------------------------------------------------------------"
case $LANG in
  fr_FR)
          case $UPDATE in
            0) echo "Installation de KPlaylist termine !" ;;
            *) echo "Mise  jour de KPlaylist termine !" ;;
          esac
          echo "Pour plus de dtails, visitez http://wiki.contribs.org/KPlaylist/fr" ;;
      *)
          case $UPDATE in
            0) echo "Kplaylist Installation finished!" ;;
            *) echo "Kplaylist Update finished!" ;;
          esac
          echo "For more details, see http://wiki.contribs.org/KPlaylist" ;;
esac
echo "-------------------------------------------------------------------------------"


%preun
if [ $1 = 0 ] ; then
  mv /usr/share/doc/kplaylist-1.7.426/Sources/DO_NOT_USE_OR_DELETE/KPlaylist-Full-Uninstall.sh /root/
fi


%postun
if [ $1 = 0 ] ; then
  /sbin/e-smith/expand-template /etc/samba/smb.conf
  /sbin/e-smith/expand-template /etc/httpd/conf/httpd.conf
  /etc/init.d/smbd restart 2>/dev/null >/dev/null
  service smb restart 2>/dev/null >/dev/null
  /etc/rc7.d/S86httpd-e-smith sigusr1 2>/dev/null >/dev/null
  
  echo "Uninstallation finished!"
  echo " "
  echo "If you want to completly remove KPlaylist"
  echo "(installation files, MySQL user+database)"
  echo "please issue the following command at the prompt:"
  echo "# sh /root/KPlaylist-Full-Uninstall.sh"
fi


%files -f %{name}-%{version}-filelist


%defattr(-,root,root)
